﻿<h1 id="layer-2-security">Layer 2 Security</h1>
<h3 id="--securing-our-layer-2-infrastructure-is-a-very-important-component-when-designing-and-configuring-lans-and-the-campus-network-as-network-administratosengineers-we-must-secure-the-control-plane-and-data-plane-of-our-switched-network-mitigating-threats-and-malicious-actors-should-be-apart-of-the-baseline-for-our-layer-2-infrastructure">- Securing our Layer 2 Infrastructure is a very important component when designing and configuring LANs and the Campus Network. As network administratos/Engineers we must secure the control plane and data plane of our Switched network. Mitigating threats and malicious actors should be apart of the baseline for our Layer 2 infrastructure</h3>
<h3 id="--to-ensure-we-take-a-defense-in-depth-approach-we-must-implement-logical-controls-on-our-network-devices-this-is-the-role-we-play-as-networking-professionals">- To ensure we take a Defense in Depth approach we must implement logical controls on our Network devices, this is the role we play as networking professionals.</h3>
<h3 id="--there-are-many-technologies-we-can-implement-on-our-switches-control-plane-policing-and-protection-dhcp-snooping-dynamic-arp-inspection-private-vlans-storm-control-bpdu-guard-and-stp-security-vacls-port-security-and-nac-these-are-some-of-the-most-common-protections-we-can-implement-via-cli-to-the-cisco-ios-to-protect-our-switched-campus-networks">- There are many technologies we can implement on our switches. Control plane policing and protection, DHCP Snooping, Dynamic ARP inspection, Private VLANs, Storm Control, BPDU Guard and STP security, VACLS, Port Security, and NAC. These are some of the most common protections we can implement via CLI to the Cisco iOS to protect our switched campus networks.</h3>
<h1 id="dhcp-snooping">DHCP Snooping</h1>
<h3 id="dhcp-snooping-protects-our-switched-architecture-from-rogue-dhcp-servers-that-are-performing-mitm-attackers-to-assign-a-malicious-default-gateway-or-dns-server-ips-to-clients">DHCP Snooping protects our switched architecture from rogue DHCP servers that are performing MITM attackers to assign a malicious default gateway or DNS server IP's to clients.</h3>
<p><img src="dhcp_snooping_network.png" alt="" /></p>
<ul>
<li><p>DHCP Snooping is configured on our access and distribution switches in a Cisco 3-Tier topology. The goal of DHCP snooping is to authenticate which interfaces should accept DHCP messages and which shouldnt. DHCP snooping uses <strong>&quot;trusted&quot;</strong> and <strong>'untrusted'</strong> ports to ensure no rogue DHCP servers can be used to allocate IP addresssing to our clients.</p>
</li>
<li><p>DHCP server messages (DHCPOffer, DHCPAck) will only be accepted on the configured <strong>&quot;Trusted&quot;</strong> ports.</p>
</li>
<li><p>DHCP client messages (DHCPDiscover, DHCPRequest) will only be accpeted on the configured <strong>&quot;untrusted&quot;</strong> ports. If a rogue DHCP service is running on a clients computer, and the service tries to send a DHCPOffer or DHCPAck message, the switchport or VLAN which is configured as untrusted will drop that traffic.</p>
</li>
<li><p>Successful Client-DHCP server exchanges will populate what is called the <strong>&quot;DHCP Snooping Binding Table&quot;</strong>. This table will contain all the current DHCP leases that were authenticated via DHCP snooping.</p>
</li>
</ul>
<h1 id="arp-spoofing">ARP Spoofing</h1>
<h3 id="the-address-resolution-protocol-is-used-to-map-layer-3-to-layer-2-information-so-endpoints-have-reachability-to-the-default-gateway-endpoints-and-network-devices-will-store-this-mapping-information-in-their-arp-table-when-a-device-is-statically-set-or-dynamically-an-ip-address-that-device-knows-the-ip-address-of-the-default-gateway-but-does-not-know-the-mac-address-an-arp-requestpacket-is-used-to-discover-the-mac-address-of-the-default-gateway-arp-spoofing-is-when-a-rogue-device-claims-to-have-the-default-gateways-mac-address-by-responding-to-that-arp-request-when-a-rogue-device-does-this-the-client-will-send-all-traffic-to-that-rogue-device-essentially-performing-a-mitm-attack">The address resolution protocol is used to map Layer 3 to Layer 2 information so endpoints have reachability to the default gateway. Endpoints and Network devices will store this mapping information in their <strong>&quot;ARP Table&quot;</strong>. When a device is statically set, or dynamically an IP address that device knows the IP address of the Default Gateway, but does not know the MAC address. An ARP request/packet is used to discover the MAC address of the default gateway. ARP spoofing is when a rogue device claims to have the Default Gateway's MAC address by responding to that ARP request. When a rogue device does this the client will send all traffic to that rogue device. Essentially performing a MITM attack.</h3>
<p><img src="arp_network_design.png" alt="" /></p>
<ul>
<li>An ARP spoofing attack is easy to perform if there is no way to authenticate which ARP packets are not malicious. Only the true default gateway should respond to an ARP request from a user looking for the Default Gateway.</li>
</ul>
<p><img src="ARP_spoofing_attack.png" alt="" /></p>
<ul>
<li>Dynamic ARP inspection enables a switch to verify which device on the network is allowed to respond to an ARP request. DAI (Dynamic ARP inspection) builds a table that is based of the DHCP snooping table and will drop any ARP frames with L2-L3 mappings not matching an entry in the DAI table.</li>
</ul>
<p><img src="DAI_image_from_google.gif" alt="" /></p>
<h1 id="bpduguard-and-stp">BPDUGuard and STP</h1>
<h3 id="the-spanning-tree-protocol-is-a-control-plane-protocol-which-prevents-switching-loops-by-electing-a-switch-and-setting-ports-in-the-non-root-switches-as-either-forwarding-or-discarding-stp-uses-bridge-protcol-datagram-units-to-perform-the-stp-root-election-these-bpdus-can-be-manipulated-to-perform-layer-2-attacks-like-a-root-bridge-takeover-which-is-done-by-sending-superior-bpdus-or-a-bpdu-dos-attack">The spanning-tree protocol is a control plane protocol which prevents switching loops by electing a <strong>&quot;switch&quot;</strong> and setting ports in the non-root switches as either forwarding or discarding. STP uses Bridge Protcol Datagram Units to perform the STP Root election. These BPDU's can be manipulated to perform Layer 2 attacks like a <strong>&quot;Root Bridge Takeover&quot;</strong> which is done by sending <strong>&quot;superior&quot;</strong> BPDU's, or a BPDU DoS attack.</h3>
<p><img src="stp_network.png" alt="" /></p>
<ul>
<li><p>Superior BDPU's can be sent from a user workstation to manipulate the STP election in the switched network. BPDU's are meant to only be sent between switches and trunk ports to stop a broadcast storm and switching loop in the Layer 2 Architecture. However, by default BPDU's are sent out all active switchports. This allows users to downloand software onto their workstation to send <strong>&quot;Superior BPDU's&quot;</strong> through the network.</p>
</li>
<li><p>Rootguard is a feature which can prevent a <strong>&quot;Root Bridge Takeover&quot;</strong> attack. Root Guard will prevent a port from transitioning to the <strong>&quot;root&quot;</strong> port. This <strong>&quot;root&quot;</strong> forwards frames towards the root switch. So essentially if a switch is the current root bridge, and an interface receives a Superior BPDU, root guard will prevent the interface from transitioning to forward to a new root bridge.</p>
</li>
</ul>
<p><img src="root_guard_image.png" alt="" /></p>
<ul>
<li><p>BPDU DoS is a BPDU flooding attack performed from a users work station. When BPDU's are sent through the switched network they generate <strong>&quot;TCNs&quot;</strong> (Topology Change Notifications).These control plane messages require CPU calcuation from the switches CPU; so when a user can maliciously manipulate how many TCN's are performed through the switched network they create a DoS attack using BPDUs.</p>
</li>
<li><p>BPDUGuard will prevent against BDPU Flooding attacks by placing any ports configured with BPDUGuard into an <strong>&quot;err-disabled&quot;</strong> mode when the port recieves a BPDU.</p>
</li>
</ul>
<p><img src="bpduguard_config.png" alt="" /></p>
<h1 id="port-security">Port Security</h1>
<h3 id="implementing-switchport-port-security-on-the-access-interfaces-of-switches-protects-us-from-rogue-devices-and-endpoint-attempting-to-perform-a-cam-flooding-attack">Implementing <strong>switchport port-security</strong> on the access interfaces of switches protects us from rogue devices, and endpoint attempting to perform a CAM flooding attack.</h3>
<p><img src="port_security_image.png" alt="" /></p>
<ul>
<li><p>Switches make forwarding decisions based off destination MAC addresses. The CAM table (MAC Address table), is the forwarding table that a switch will referrence to forward frames. Switches do have a limited amount of CPU and space available for the CAM table.</p>
</li>
<li><p>Malicious Users can exploit the limited resources of a switch by flooding the switch with fake MAC addresses. This can easily be done with software from a users computer. A CAM flooding attack is essentially a denial of service attack against the switch.</p>
</li>
<li><p>To protect against this attack and also rogue devices, like a COTS WAP from being plugged in, we can configure <strong>port-security</strong> to limit the amount of MAC addresses allowed per interface. Port-security can shutdown or place a port into <strong>&quot;err-disabled&quot;</strong> mode to prevent CAM flooding or rogue devices.</p>
</li>
</ul>
<p><img src="port_security_table.png" alt="" /></p>
<ul>
<li>Port security has three different modes that you can configure per port. The default mode is <strong>&quot;shutdown&quot;</strong>, which will place the port into an <strong>&quot;err-disabled&quot;</strong> mode and shutdown the interface.</li>
</ul>
